"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileTree = void 0;
var react_1 = __importStar(require("react"));
var react_virtualized_1 = require("react-virtualized");
var TreeItem_1 = require("./TreeItem");
var useEvent_1 = __importDefault(require("./useEvent"));
var useTree_1 = __importDefault(require("./useTree"));
var utils_1 = require("./utils");
function defaultEmptyRenderer() {
    return react_1.default.createElement("div", { className: "file-tree__empty" }, "\u65E0\u5185\u5BB9");
}
exports.FileTree = (0, react_1.forwardRef)(function (_a, ref) {
    var rootUri = _a.rootUri, fileService = _a.fileService, emptyRenderer = _a.emptyRenderer, treeItemRenderer = _a.treeItemRenderer, treeItemSort = _a.treeItemSort, onError = _a.onError, draggable = _a.draggable, doFilter = _a.doFilter, indent = _a.indent, rowHeight = _a.rowHeight, indentUnit = _a.indentUnit, onContextMenu = _a.onContextMenu, onDrop = _a.onDrop, onRootTreeChange = _a.onRootTreeChange, onTreeItemClick = _a.onTreeItemClick;
    var _b = (0, useTree_1.default)(fileService, onError), tree = _b[0], handler = _b[1];
    // 初始化tree
    (0, react_1.useEffect)(function () {
        if (!rootUri) {
            handler.setRootNode(undefined);
            onRootTreeChange === null || onRootTreeChange === void 0 ? void 0 : onRootTreeChange(undefined);
        }
        else {
            fileService
                .read(rootUri)
                .then(function (treeNode) {
                handler === null || handler === void 0 ? void 0 : handler.setRootNode(treeNode);
                onRootTreeChange === null || onRootTreeChange === void 0 ? void 0 : onRootTreeChange(treeNode);
            })
                .catch(onError);
        }
    }, [rootUri]);
    var items = (0, utils_1.flatTreeData)(tree ? [tree] : [], treeItemSort).filter(function (item) { return (doFilter ? doFilter(item) : true); });
    var handleClick = (0, useEvent_1.default)(function (treeNode) {
        if (onTreeItemClick) {
            onTreeItemClick(treeNode);
            return;
        }
        if (treeNode.type === "directory") {
            handler.expand(treeNode.uri, !treeNode.expanded);
        }
    });
    var itemRender = treeItemRenderer
        ? function (treeNode) { return treeItemRenderer === null || treeItemRenderer === void 0 ? void 0 : treeItemRenderer(treeNode); }
        : function (treeNode) { return react_1.default.createElement("div", null, (0, utils_1.getFileName)(treeNode.uri)); };
    // 悬停时展开目录
    var timeoutRef = (0, react_1.useRef)(0);
    var handleDragOver = (0, useEvent_1.default)(function (event, treeNode) {
        clearTimeout(timeoutRef.current);
        if (treeNode.type === "directory" && !treeNode.expanded) {
            // 延时一点展开目录或者收缩目录，防止误操作
            timeoutRef.current = window.setTimeout(function () {
                handler.expand(treeNode.uri, true);
            }, 500);
        }
    });
    // 移动文件
    var handleDrop = (0, useEvent_1.default)(function (event, fromUri, toUri) { return __awaiter(void 0, void 0, void 0, function () {
        var fromNode, toNode;
        return __generator(this, function (_a) {
            if (fromUri === toUri) {
                return [2 /*return*/];
            }
            fromNode = handler.getNode(fromUri);
            toNode = handler.getNode(toUri);
            if (!fromNode || !toNode) {
                return [2 /*return*/];
            }
            if (toNode.type !== "directory") {
                toNode = (0, utils_1.getParentNode)(tree, toNode.uri);
            }
            if ((toNode === null || toNode === void 0 ? void 0 : toNode.type) === "directory") {
                if (onDrop) {
                    onDrop(fromUri, toNode.uri);
                }
                else {
                    handler.move(fromUri, toNode.uri);
                }
            }
            return [2 /*return*/];
        });
    }); });
    (0, react_1.useImperativeHandle)(ref, function () {
        return handler;
    }, []);
    var rowRenderer = function (params) {
        var treeNode = items[params.index];
        var indentNum = indent || 10;
        return (react_1.default.createElement(TreeItem_1.TreeItem, { draggable: draggable, key: treeNode.uri, indentUnit: indentUnit || "px", indent: indentNum * (0, utils_1.calcLevel)(treeNode.uri, rootUri || ""), style: params.style, treeNode: treeNode, onContextMenu: onContextMenu, treeItemRenderer: itemRender, onClick: handleClick, onDragOver: handleDragOver, onDrop: handleDrop }));
    };
    return (react_1.default.createElement(react_virtualized_1.AutoSizer, null, function (_a) {
        var height = _a.height, width = _a.width;
        return (react_1.default.createElement(react_virtualized_1.List, { className: "file-tree", height: height, width: width, overscanRowCount: 30, noRowsRenderer: emptyRenderer || defaultEmptyRenderer, rowCount: items.length, rowHeight: rowHeight || 30, rowRenderer: rowRenderer }));
    }));
});
