/// <reference types="react" />
import { FileService, TreeNode } from "./type";
declare function useTree(fileService: FileService, onError?: (err: Error) => void): readonly [TreeNode | undefined, {
    getRootNode: () => TreeNode | undefined;
    setRootNode: import("react").Dispatch<import("react").SetStateAction<TreeNode | undefined>>;
    getNode: (uri: string) => TreeNode | null | undefined;
    addNode: (uri: string, childNode: TreeNode) => void;
    replaceNode: (uri: string, replacedNode: TreeNode) => void;
    updateNode: (uri: string, record: Partial<TreeNode>) => void;
    removeNode: (uri: string) => void;
    expand: (uri: string, expanded: boolean) => Promise<void>;
    create: (uri: string, childNode: TreeNode) => Promise<void>;
    rename: (uri: string, name: string) => Promise<void>;
    remove: (uri: string) => Promise<void>;
    move: (uri: string, targetDirUri: string) => Promise<void>;
}];
export default useTree;
