"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useEvent_1 = __importDefault(require("./useEvent"));
var utils_1 = require("./utils");
function useTree(fileService, onError) {
    var _this = this;
    var _a = (0, react_1.useState)(), tree = _a[0], setTree = _a[1];
    // 修改节点
    var updateNode = (0, useEvent_1.default)(function (uri, record) {
        setTree(function (t) { return (0, utils_1.mergeTreeNodeProps)(t, uri, record); });
    });
    var getRootNode = (0, useEvent_1.default)(function () { return tree; });
    var getNode = (0, useEvent_1.default)(function (uri) { return (0, utils_1.getNodeByUri)(tree, uri); });
    // 展开节点
    var expand = (0, useEvent_1.default)(function (uri, expanded) { return __awaiter(_this, void 0, void 0, function () {
        var treeNode, children_1, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    treeNode = getNode(uri);
                    if ((treeNode === null || treeNode === void 0 ? void 0 : treeNode.type) !== "directory" || treeNode.async === "loading") {
                        return [2 /*return*/];
                    }
                    if (!((treeNode === null || treeNode === void 0 ? void 0 : treeNode.async) === "unload")) return [3 /*break*/, 5];
                    updateNode(uri, { async: "loading" });
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fileService.readdir(treeNode.uri)];
                case 2:
                    children_1 = _a.sent();
                    setTree(function (t) {
                        return (0, utils_1.mergeTreeNodeProps)(t, uri, {
                            async: "loaded",
                            expanded: expanded,
                            children: children_1,
                        });
                    });
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    updateNode(uri, { async: "unload" });
                    onError === null || onError === void 0 ? void 0 : onError(err_1);
                    return [3 /*break*/, 4];
                case 4: return [3 /*break*/, 6];
                case 5:
                    setTree(function (t) { return (0, utils_1.mergeTreeNodeProps)(t, uri, { expanded: expanded }); });
                    _a.label = 6;
                case 6: return [2 /*return*/];
            }
        });
    }); });
    // 替换节点
    var replaceNode = (0, useEvent_1.default)(function (uri, replacedNode) {
        setTree(function (t) { return (0, utils_1.replaceTreeNode)(t, uri, replacedNode); });
    });
    // 增加节点
    var addNode = (0, useEvent_1.default)(function (uri, childNode) {
        setTree(function (t) { return (0, utils_1.addChildTo)(t, uri, childNode); });
    });
    var removeNode = (0, useEvent_1.default)(function (uri) {
        setTree(function (t) { return (0, utils_1.removeNode)(t, uri); });
    });
    var rename = (0, useEvent_1.default)(function (uri, name) { return __awaiter(_this, void 0, void 0, function () {
        var treeNode, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fileService.rename(uri, name)];
                case 1:
                    treeNode = _a.sent();
                    replaceNode(uri, treeNode);
                    return [3 /*break*/, 3];
                case 2:
                    err_2 = _a.sent();
                    onError === null || onError === void 0 ? void 0 : onError(err_2);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    // 删除节点
    var remove = (0, useEvent_1.default)(function (uri) { return __awaiter(_this, void 0, void 0, function () {
        var err_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fileService.remove(uri)];
                case 1:
                    _a.sent();
                    setTree(function (t) {
                        console.log(t, uri);
                        return (0, utils_1.removeNode)(t, uri);
                    });
                    return [3 /*break*/, 3];
                case 2:
                    err_3 = _a.sent();
                    onError === null || onError === void 0 ? void 0 : onError(err_3);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    var create = (0, useEvent_1.default)(function (uri, childNode) { return __awaiter(_this, void 0, void 0, function () {
        var node, finalTree_1, err_4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fileService.create(uri, childNode)];
                case 1:
                    node = _a.sent();
                    finalTree_1 = (0, utils_1.removeNode)(tree, childNode.uri);
                    setTree(function () { return (0, utils_1.addChildTo)(finalTree_1, uri, childNode); });
                    return [3 /*break*/, 3];
                case 2:
                    err_4 = _a.sent();
                    onError === null || onError === void 0 ? void 0 : onError(err_4);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    var move = (0, useEvent_1.default)(function (uri, targetDirUri) { return __awaiter(_this, void 0, void 0, function () {
        var treeNode_1, err_5;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fileService.move(uri, targetDirUri)];
                case 1:
                    treeNode_1 = _a.sent();
                    setTree(function (t) {
                        var finalTree = (0, utils_1.removeNode)(t, uri);
                        return (0, utils_1.addChildTo)(finalTree, targetDirUri, treeNode_1);
                    });
                    return [3 /*break*/, 3];
                case 2:
                    err_5 = _a.sent();
                    onError === null || onError === void 0 ? void 0 : onError(err_5);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    var handler = (0, react_1.useMemo)(function () { return ({
        getRootNode: getRootNode,
        setRootNode: setTree,
        getNode: getNode,
        addNode: addNode,
        replaceNode: replaceNode,
        updateNode: updateNode,
        removeNode: removeNode,
        expand: expand,
        create: create,
        rename: rename,
        remove: remove,
        move: move,
    }); }, []);
    return [tree, handler];
}
exports.default = useTree;
