import { TreeNode } from "../lib/type";
declare type Action<T, P> = {
    type: T;
    payload: P;
};
declare type ReadAction = Action<"read", {
    uri: string;
}>;
declare type CreateAction = Action<"create", {
    uri: string;
    childNode: TreeNode;
}>;
declare type RemoveAction = Action<"remove", {
    uri: string;
}>;
declare type MoveAction = Action<"move", {
    fromUri: string;
    toUri: string;
}>;
declare type ReadDirAction = Action<"readdir", {
    uri: string;
}>;
declare type RenameAction = Action<"rename", {
    uri: string;
    name: string;
}>;
export declare type FileAction = ReadAction | CreateAction | RemoveAction | MoveAction | ReadDirAction | RenameAction;
export {};
